//
//  ViewController.swift
//  TestMyTorus
//
//  Created by Don McBrien on 28/03/2020.
//  Copyright © 2020 Don McBrien. All rights reserved.
//

import Cocoa
import MetalKit

class ViewController: NSViewController {
   
   var metalView: MTKView!    // the view
   var renderer: Renderer!    // the view object's delegate
   
   override func viewDidLoad() {
      super.viewDidLoad()
      
      prepareMetal()
   }
   
   func prepareMetal() {
      // First we recast self.view as an MTKView and store the reference
      guard let metalViewTemp = self.view as? MTKView else {
         fatalError("View attached to ViewController is not an MTKView!")
      }
      metalView = metalViewTemp
      
      // Then we create an instance of our Renderer object ...
      renderer = Renderer(view: metalView)
      
      // ... and set it as the delegate of metalView
      metalView.delegate = renderer
   }
}
